// Package logic -----------------------------
// @file      : artistinfo_artshow.go
// @author    : JJXu
// @contact   : wavingbear@163.com
// @time      : 2023/3/7 15:55
// -------------------------------------------
package logic

import (
	"github.com/fonchain/fonchain-artistinfo/cmd/model"
	"github.com/fonchain/fonchain-artistinfo/pb/artistinfoArtshow"
	db "github.com/fonchain/fonchain-artistinfo/pkg/db"
	"github.com/fonchain/fonchain-artistinfo/pkg/util/stime"
)

type ArtshowLogic struct{}

func (a ArtshowLogic) GetArtshowHistroyList(request *artistinfoArtshow.GetArtshowHistroyListRequest) (data *artistinfoArtshow.GetArtshowHistroyListResponse, err error) {
	data = &artistinfoArtshow.GetArtshowHistroyListResponse{}
	var (
		artworkSupplementList = []model.ArtshowArtistSupplement{}
	)
	var (
		//画家补充信息
		db_artistSupplement = db.DB.Model(&model.ArtshowArtistSupplement{}).Where("artist_uid = ?", request.ArtistUid).Order("lock_time desc")
		//画家指数
		//db_artistIndex = db.DB.Model(&model.ArtshowArtistIndex{}).Where("artist_uid = ?", request.ArtistUid).Order("lock_time desc")
		////画作补充西悉尼
		//db_artworkSupplement = db.DB.Model(&model.ArtworkLockRecord{})
	)
	if request.AuditStatus != 0 {
		db_artistSupplement = db_artistSupplement.Where("audit_status = ?", request.AuditStatus)
	}

	err = db_artistSupplement.Find(&artworkSupplementList).Error
	if err != nil {
		return nil, err
	}
	var dataGroups = []artistinfoArtshow.TimeGroup{}
	var thisTime = ""
	var thisIndex = -1
	for _, v := range artworkSupplementList {
		if thisTime == "" || v.LockTime != thisTime {
			thisTime = v.LockTime
			thisIndex++
		}

		dataGroups = append(dataGroups, artistinfoArtshow.TimeGroup{
			Time:                  thisTime,
			ArtworkSupplementList: []*artistinfoArtshow.ArtworkSupplementData{},
			ArtistSupplementList:  []*artistinfoArtshow.ArtistSupplementData{},
			ArtistIndexList:       []*artistinfoArtshow.ArtistIndexData{},
			ArtistVideoList:       []*artistinfoArtshow.ArtistVideoData{},
		})

		dataGroups[thisIndex].ArtworkSupplementList = append(dataGroups[thisIndex].ArtworkSupplementList, &artistinfoArtshow.ArtworkSupplementData{
			ArtistUid:       v.ArtistUid,
			Status:          v.Status,
			LockTime:        v.LockTime,
			AuditStatus:     int64(v.AuditStatus),
			AuditMark1:      v.AuditMark1,
			AuditMark2:      v.AuditMark2,
			ArtistName:      v.ArtistName,
			ArtistProfile:   v.ArtistProfile,
			CountryArtLevel: v.CountryArtLevel,
			ArtistCertPic:   v.ArtistCertPic,
			BankNum:         v.BankNum,
			BankName:        v.BankName,
			Id:              v.ID,
			CreatedAt:       stime.TimeToString(v.CreatedAt, stime.Format_Normal_YMDhms),
			UpdatedAt:       stime.TimeToString(v.CreatedAt, stime.Format_Normal_YMDhms),
			DeletedAt:       int64(v.DeletedAt),
		})
	}

	//查询画家补充信息
	var artistSupplementDatas []model.ArtshowArtistSupplement
	db.DB.Where("status = ?").Order("").Find(&artistSupplementDatas)
	return nil, nil
}
